# ft-euler: a path planning solution
*Because everything's named after Euler*

[![Test ft-euler](https://github.com/FT-Autonomous/ft-euler/actions/workflows/build.yml/badge.svg)](https://github.com/FT-Autonomous/ft-euler/actions/workflows/build.yml)

TBD, more to come

## Dependencies
- dearpygui 
- numpy 
- scipy
- rospy (optional)

## Setup
Make sure your terminal is in the virtual environment.

Install the dependencies into the virtual environment:
```bash
pip install dearpygui numpy scipy
```

Run the simulator:
```bash
python run_simulator.py 
```

To use the simulator with ROS, you'll need to follow the [setup process](http://wiki.ros.org/noetic/Installation).

## Modules
### dev
Tools for developing our path planning solution (simulator, graphics, file import code, etc.)
### geometry
Classes and functions for geometric primitives (point, line, triangle)
### pathfinding
Finds the optimal path from input data
### export
Contains ROS specific code.
The continuous node can be executed with:

```bash
rosrun ft_euler node.py
```

## Testing
At present, we use the built-in testing framework ```unittest```.

You can run unit tests by using the following command at the root of the project:
```bash
python -m unittest
```
This will run all implemented unit tests.

## Credits

EUFS for track data used in testing: https://gitlab.com/eufs/eufs_sim
