# Python standard library
from csv import DictReader
from typing import List

# ft-euler
from ft_euler.pathfinding.Cone import Cone


def get_cones_from_file(filename: str) -> List[Cone]:
    cones = []
    with open(filename, newline='') as csvfile:
        reader = DictReader(csvfile)
        next(reader)  # Skip the first row
        for row in reader:
            cones.append(Cone(row['tag'], float(row['x']), float(row['y'])))

    return cones


def main() -> None:
    cones = get_cones_from_file("../../tracks/acceleration.csv")
    for cone in cones:
        print(cone)

if __name__ == "__main__":
    main()

