import numpy as np


class Track:
    def __init__(self, name, cones):
        self.name = name
        self.cones = cones
        
    def strip_color_information(self) -> None:
        for cone in self.cones:
            cone.color = "unknown"

    def get_blue_cones(self):
        blue_cones = []

        for cone in self.cones:
            if cone.color == "blue":
                blue_cones.append(cone)

        return blue_cones

    def get_yellow_cones(self):
        yellow_cones = []

        for cone in self.cones:
            if cone.color == "yellow":
                yellow_cones.append(cone)

        return yellow_cones

    def get_big_orange_cones(self):
        big_orange_cones = []

        for cone in self.cones:
            if cone.color == "big_orange":
                big_orange_cones.append(cone)

        return big_orange_cones

    def get_orange_cones(self):
        orange_cones = []

        for cone in self.cones:
            if cone.color == "orange":
                orange_cones.append(cone)

        return orange_cones

    def get_car_start_cone(self):
        for cone in self.cones:
            if cone.color == "car_start":
                return cone

    def to_np_array_of_pos_lists(self, include_blue=True, include_yellow=True, include_big_orange=True, include_orange=True, include_car_start=True):
        cones = []

        if include_blue:
            blue_cones = self.get_blue_cones()
            for cone in blue_cones:
                cones.append(cone)

        if include_yellow:
            yellow_cones = self.get_yellow_cones()
            for cone in yellow_cones:
                cones.append(cone)

        if include_big_orange:
            big_orange_cones = self.get_big_orange_cones()
            for cone in big_orange_cones:
                cones.append(cone)

        if include_orange:
            orange_cones = self.get_orange_cones()
            for cone in orange_cones:
                cones.append(cone)

        if include_car_start:
            car_start = self.get_car_start_cone()
            cones.append(car_start)

        np_array_of_pos_lists = np.empty([len(cones), 2])
        for index, cone in enumerate(cones):
            np_array_of_pos_lists[index] = cone.pos.to_float_list()

        return np_array_of_pos_lists

    def __eq__(self, other):
        if self.name == other.name and self.cones == other.cones:
            return True
        else:
            return False
